function [p,tau,f,STC,SFC,S] = DS(y,dx,dt,p_min,p_max,L,T1,T2,DP)
%    
%  .. 2016 akhmetsadinrd@mail.ru
% :
% y  -     NxM;
% dx -   ;
% dt -   ;
% p_min,p_max,L -      slowness;
% T1 -    ;
% T2 -     ;
% DP     (D)   (P)  N_FFT2xL.
% :
% p -  slowness ( );
% tau -    ;
% f -  ;
% STC - 1;
% SFC -  ;
% S   - 2.
[N,M] = size(y);
tau = (0:N-1)'*dt;                x = (0:M-1)*dx-(M-1)*dx/2;
N_FFT = 2^nextpow2(N);            N_FFT2 = N_FFT/2;
p = linspace(p_min,p_max,L);
f = (0:N_FFT2-1)'*(1/(N_FFT*dt)); F = repmat(f,1,L);
j = sqrt(-1);               %  
%%   
Y = fft(y,N_FFT,1);         % 
B_STC = zeros(N,L);      A_STC = B_STC;
B_SFC = zeros(N_FFT2,L); A_SFC = B_SFC;
C = j*2*pi*F.*DP;           %    D ( )
Z = zeros(N_FFT,L);
for m = 1:M
    temp1 = repmat(Y(1:N_FFT2,m),1,L);
temp2 = temp1.*exp(x(m)*C);
    Z(1:N_FFT2,:) = temp2;
    Z(N_FFT:-1:N_FFT2+2,:) = conj(temp2(2:N_FFT2,:));
    Z = real(ifft(Z,[],1)); % 
    temp3 = Z(1:N,:);
    B_STC = B_STC + temp3; A_STC = A_STC + temp3.^2;
    B_SFC = B_SFC + temp2; A_SFC = A_SFC + abs(temp1).^2;
end
B_STC = B_STC.^2;      STC = zeros(N,L);
B_SFC = abs(B_SFC).^2; SFC = zeros(N_FFT2,L);
for i = 1:L
    STC(:,i) = smooth(B_STC(:,i),T1)./smooth(A_STC(:,i),T1)/M;
    SFC(:,i) = smooth(B_SFC(:,i),T2)./smooth(A_SFC(:,i),T2)/M;
end
S = sum(B_SFC)./sum(A_SFC)/M;
